// Sample client to test server with

 /*
  Ok set a var called expected and one called received
  If received is less than expected throw it away
  If received is greater than expected store in 
  linked list structure for later use (insertion sort on id)
  Set up nack counter for that expected and send 
  nacks to server looking for that one
*/

/*
 Return frame to requesting user, or some sort of error
 return code to the program saying that the requested
 data is not available 
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/types.h>
#include <signal.h>
#include <inttypes.h>
#include "srp.h"

int main(int argc, char **argv) {
int test;
struct srp_client_socket *sock; 
char buffer[SRP_MAX_DATA_SIZE];
  
  struct srp_nack_packet srp_nack;
  int size_localaddr;

  if (argc != 4) {
    printf("Usage:  client <host> <port> <latency>\n");
    exit(1);
  } 
     
(struct srp_client_socket *)sock = ClientInit();
     /*
      * All of this socket stuff will be done someday by the user program not by SRP
      */

                  /* Lets lookup the address here  */
  printf("H: %s P: %d lat: %d\n",argv[1],atoi(argv[2]),atoi(argv[3]));
  lookup_addr(argv[1], atoi(argv[2]), "udp", &(sock->addr));
      
  /* setup and connect to address in above line */
  if ((sock->socketnum = make_sock(sock->addr, SOCK_DGRAM)) == -1)
     {
      exit(1);
     }
 size_localaddr = sizeof(struct sockaddr_in);



      srp_nack.status = SRP_STATUS_MISSING;
      srp_nack.srp_data_id = 1;
      printf("Sending init message: %d\n",1);
      sendto(sock->socketnum, &srp_nack, sizeof(struct srp_nack_packet), 0, 
            &(sock->addr), sizeof(struct sockaddr_in));
 
do
  {
test = ClientRead(sock ,&buffer,SRP_MAX_DATA_SIZE);
printf("returned to main\n");
  }while(1);
printf("returned to main\n");

/* We are finished reading from the socket, so close the connection */

    close(sock->socketnum);

}



struct srp_client_socket * ClientInit()
{
struct srp_client_socket *new;
 new = malloc(sizeof(struct srp_client_socket));
  if (new == NULL)
   {
   printf("Error cannot malloc space for client_socket\n");
   exit(1);
   }
  return(new);
 }



int ClientRead(struct srp_client_socket *socketStr, void *buffer, int max_data_size)
  {
  struct srp_data_packet srp_in_pkt;
  struct srp_data_node *srp_from_list = NULL;
  int size_localaddr;
  char message[20];
  struct timeval tv;
  int retval;
  int missing;
  fd_set readset,writeset,eset;

  
 
   socketStr->nack_remain = 5;
  /* check local linked list thingy here 
   * If the expected number is in the list,
   * get the data out, and delete the node
   */
   srp_from_list = check_list((&(socketStr->dnode)),socketStr->expected);
   if(srp_from_list != NULL)
     {
     printf("from list %d %d\n",srp_from_list->data_id,srp_from_list->data_len);



       if (srp_from_list->data_len > max_data_size)
       {
	 /* the amount read in is greater than the max size */
     memcpy((struct srp_data_packet *)buffer, srp_from_list->data, max_data_size);
     socketStr->expected++;
     return(max_data_size);
       }
     else
       {
	 /* the packet data is either less than the max, or equal
	  * both are handled the same way
	  */
       memcpy((struct srp_data_packet *)buffer, srp_from_list->data,srp_from_list->data_len);
       socketStr->expected++;
       return(srp_from_list->data_len);
       }
     free(srp_from_list);     
     }
  


do
  {
 /*
   * Need to do two things here, receive on the socket and store the data in
   * some sort of linked list
   * Also if the needed one has not come in, send a nack
   */
    
    size_localaddr = sizeof(struct sockaddr_in); 
  
    FD_ZERO(&readset);
    FD_ZERO(&writeset);
    FD_ZERO(&eset);
    FD_SET(socketStr->socketnum, &readset);
    FD_SET(socketStr->socketnum, &eset);
   
    tv.tv_sec = 7;
    tv.tv_usec = 500;

   if ((retval = select(socketStr->socketnum +1, &readset, &writeset, &eset,&tv)) < 0)
     {
     printf("select failed\n");
     }

   if (FD_ISSET(socketStr->socketnum,&eset))
     {
       printf("Socket Exception\n");
       return(-1);
     }
   if(retval)
     {
       /* There is activity on the socket so read from it */
     if(recvfrom(socketStr->socketnum,&srp_in_pkt, 
        sizeof(struct srp_data_packet), 0, 
        NULL, NULL) < 0)
       {
       printf("recvfrom Exception\n");
       return(-1);
       }
   /* We got something in from the socket, lets see what it is */
    printf("made it here after read\n");
    

    printf("%s: data_id: %d data: %s\n", inet_ntoa
          (socketStr->peeraddr.sin_addr),srp_in_pkt.srp_data_id, 
           srp_in_pkt.data);



  if(srp_in_pkt.srp_data_id < socketStr->expected)
   {
    /* The data_id in the incoming message is less than the expected one
     * so do nothing with the incoming message.
    */
     
    } 
  
    if (srp_in_pkt.srp_data_id > socketStr->expected)
    {
    /* The data_id in the incoming message is greater than the expected one
     * so send it to the linked list to be inserted and stored for later on
     * when the expected one arrives, set up the nack timer to nack for
     * the missing one again 
     */

      printf("we are here because %d is too far ahead\n",srp_in_pkt.srp_data_id);
      add_data(&(socketStr->dnode),srp_in_pkt.srp_data_id,srp_in_pkt.data,
                 srp_in_pkt.srp_data_size); 
      print_data(socketStr->dnode);
    }
    if (srp_in_pkt.srp_data_id == socketStr->expected)
     {

    /* If we got here it must be what we expected so return the data to the client */

       /* We also got the number we were looking for so increment the
        * value of expected .
	*/
     printf("got %d number in\n",socketStr->expected); 


     /* we have the packet we want, so lets check the size of the item coming in
      * against the max_data_size passed into the function
      * if the data coming in is less than the max_size memcpy what we have and
      * return the size placed in.
      * if the data is greater than the max_size only return max_size of data
      */
     if (srp_in_pkt.srp_data_size > max_data_size)
       {
	 /* the amount read in is greater than the max size */
     memcpy((struct srp_data_packet *)buffer, srp_in_pkt.data, max_data_size);
     socketStr->expected++;
     return(max_data_size);
       }
     else
       {
	 /* the packet data is either less than the max, or equal
	  * both are handled the same way
	  */
       memcpy((struct srp_data_packet *)buffer, srp_in_pkt.data,srp_in_pkt.srp_data_size);
       socketStr->expected++;
       return(srp_in_pkt.srp_data_size);
       }
     }
  
     }
   else
     {
       /* Timer has expired call for nack for the expected */
     printf("TIMER EXPIRED: HAVE A NICE DAY :)\n");
     missing = socketStr->expected;
     if (socketStr->nack_remain != 0)
       {
     do_nack(missing,socketStr);
     socketStr->nack_remain--;
       }
     }
  }while(socketStr->nack_remain != 0);
   socketStr->expected++;
  }
void lookup_addr(char *name, int port, char *proto, struct sockaddr_in *sin) {

  struct hostent *addr_info;
  struct servent *port_info;
  char *pAddr, **ppAddr;
  struct in_addr addr;


  if ((addr_info = gethostbyname(name)) == NULL) {perror("Could not get addr! "); exit(1); }
  //  if ((port_info = getservbyport(htons(port), "udp")) == NULL) {perror("Could not get port! "); exit(1); }

  ppAddr = addr_info->h_addr_list;
  pAddr = ppAddr[0];

  memcpy(&addr, pAddr, sizeof(struct in_addr));

  sin->sin_addr = addr;
  sin->sin_family = AF_INET;
  sin->sin_port = htons(port);
  //  sin->sin_port = port_info->s_port;

}


int make_sock(struct sockaddr_in sin, int proto) {
  int socketnum;

  if ((socketnum = socket(AF_INET, proto, 0)) < 0) {perror("Socket Error! "); return(-1);}
  if (connect(socketnum, (struct sockaddr *) &sin, sizeof(sin))) {perror("Connect error! "); return(-1);}


  return(socketnum);

}


void do_nack(int missing, struct srp_client_socket *socket)
 { 
struct srp_nack_packet srp_nack;

      srp_nack.status = SRP_STATUS_MISSING;
      srp_nack.srp_data_id = missing;
      printf("Sending: %d\n", missing);
      sendto(socket->socketnum, &srp_nack, sizeof(struct srp_nack_packet), 0, 
      &(socket->addr), sizeof(struct sockaddr_in));
 }


void add_data(struct srp_data_node **mm_data_newest, int data_id, char *data,int data_size)
  { 
 int i;
 struct srp_data_node  *new,*temp,*cur;

  if (*mm_data_newest == NULL) { 
    // Only item in list
    new = malloc(sizeof(struct srp_data_node));
    if (new == NULL)
    {
     printf("ERROR cannot malloc for linked list\n");
    }
    new->data_id = data_id;
    new->status = SRP_DATA_OK;
    new->data_len = data_size;
    if (data_size > SRP_MAX_DATA_SIZE) {
      // Error, Some data will be cut off
      memcpy(new->data, data, SRP_MAX_DATA_SIZE);
    } else {
      memcpy(new->data, data, data_size);   
    }
    new->newer = NULL;
    *mm_data_newest = new;

  } else {
     if((*mm_data_newest)->data_id == data_id)
	{
        return;
	}

       if ((*mm_data_newest)->data_id > data_id)
	{
      new = malloc(sizeof(struct srp_data_node));
      new->data_id = data_id;
      new->status = SRP_DATA_OK;
      new->data_len = data_size;
      if (data_size > SRP_MAX_DATA_SIZE) {
	// Error, Some data will be cut off
	memcpy(new->data, data, SRP_MAX_DATA_SIZE);
      } else {
	memcpy(new->data, data, data_size);   
      }      
      new->newer = (*mm_data_newest);
      (*mm_data_newest) = new;
       return;
        }
      else
       {
       /* somewhere in the middle */

      for (cur = *mm_data_newest; cur->newer != NULL; cur=cur->newer) {
       
	/* check and see if goes before */
      if(cur->newer->data_id == data_id)
	{
        return;
	}

       if (cur->newer->data_id > data_id)
	 {
         break;
        
	 }
      }/* for loop */
      new = malloc(sizeof(struct srp_data_node));
      new->data_id = data_id;
      new->status = SRP_DATA_OK;
      new->data_len = data_size;
      if (data_size > SRP_MAX_DATA_SIZE) {
	// Error, Some data will be cut off
	memcpy(new->data, data, SRP_MAX_DATA_SIZE);
      } else {
	memcpy(new->data, data, data_size);   
      }      
      new->newer = cur->newer;
      cur->newer = new;
	}
}
} /* closes function */



void print_data(struct srp_data_node *newest) {
  struct srp_data_node *cur;
  int i;

  for (cur = newest; cur != NULL; cur=cur->newer) {
    printf("Frame %d: ",cur->data_id);
    if (cur->status == SRP_DATA_OK) {
      for (i=0;i<cur->data_len;i++) {
	printf("%c", cur->data[i]);
      }
    } else {
      printf("MISSING");
    }
    printf("\n--------------\n");
  }

}

struct srp_data_node * check_list(struct srp_data_node **newest,int expid) 
 {
 struct srp_data_node *cur, *temp;
 
  if (*newest == NULL)
    {
    printf("NULL\n");
    return(NULL);
    }
  else
    {
    if ((*newest)->data_id == expid)
      {
      cur = (*newest);
      (*newest) = cur->newer;
      return(cur);
      }
    }
return(NULL); 
}

void ClientStop(struct srp_client_socket *sok)
{
 free(sok);
}
