#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/types.h>
#include "srp.h"

#define MAX_BACKLOG 10

void lookup_addr(char *, char *, char *, struct sockaddr_in *);
int make_sock(struct sockaddr_in, int);
void lookup_host(char *, int, struct sockaddr_in *);


int main (int argc, char *argv) {
  
  int socketnum, clientsock;
  struct sockaddr_in localaddr, peeraddr;
  int port;
  char host[50], buffer[50], answer[10];
  int connections;
  int size_localaddr;
  struct srp_packet srp_msg;


  if ((socketnum = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {perror("Socket Error! "); exit(1);}

  localaddr.sin_family = AF_INET;
  localaddr.sin_port = 0;
  localaddr.sin_addr.s_addr = INADDR_ANY;

  size_localaddr = sizeof(localaddr);
  if ((bind(socketnum,(struct sockaddr *) &localaddr, sizeof(localaddr))) < 0) {perror("Bind Error! "); exit(1);}
  if ((getsockname(socketnum,(struct sockaddr *)  &localaddr, &size_localaddr )) < 0) {perror("Get Port Error! "); exit(1);}

  port = localaddr.sin_port;
  if ((gethostname(host, sizeof(host))) < 0) {perror("Get Host Error! "); exit(1);}


  connections = 0;
  printf("Server running (addr: %s port: %d)\n", host, ntohs(port));

  while(1) {
    recvfrom(socketnum, &srp_msg, sizeof(struct srp_packet), 0, (struct sockaddr *) &peeraddr, &size_localaddr);
    printf("%s: %s", inet_ntoa(peeraddr.sin_addr), srp_msg.str);
  }

}


void lookup_addr(char *name, char *serv, char *proto, struct sockaddr_in *sin) {

  struct hostent *addr_info;
  struct servent *port_info;
  char *pAddr, **ppAddr;
  struct in_addr addr;


  if ((addr_info = gethostbyname(name)) == NULL) {perror("Could not get addr! "); exit(1); }
  if ((port_info = getservbyname(serv, "udp")) == NULL) {perror("Could not get port! "); exit(1); }

  ppAddr = addr_info->h_addr_list;
  pAddr = ppAddr[0];

  memcpy(&addr, pAddr, sizeof(struct in_addr));

  sin->sin_addr = addr;
  sin->sin_family = AF_INET;
  sin->sin_port = port_info->s_port;

}

void lookup_host(char *name, int port, struct sockaddr_in *sin) {

  struct hostent *addr_info;
  struct servent *port_info;
  char *pAddr, **ppAddr;
  struct in_addr addr;


  if ((addr_info = gethostbyname(name)) == NULL) {perror("Could not get addr! "); exit(1);}

  ppAddr = addr_info->h_addr_list;
  pAddr = ppAddr[0];

  memcpy(&addr, pAddr, sizeof(struct in_addr));

  sin->sin_addr = addr;
  sin->sin_family = AF_INET;
  sin->sin_port = port;

}










