// Implements a client
import java.io.*;
import java.net.*;
import java.util.*;

public class ClientTCPSendThread extends Thread {

  long packets_out = 0;
  long bytes_out = 0;
    
  private RandomAccessFile file = null;

  Socket socket;
  InetAddress address;
  int port;
  ClientBuffer cBuffer;
  int sleeptime;

  public ClientTCPSendThread(Socket socket, 
			     InetAddress address, 
			     int port, 
			     ClientBuffer cBuffer,
			     String outputfile,
			     int sleep) throws IOException {
    super("ClientTCPSendThread");
    this.socket = socket;
    this.address = address;
    this.port = port;
    this.cBuffer = cBuffer;
    this.sleeptime = sleep;

    file = new RandomAccessFile(new File(outputfile+"_tcp_s.out"), "rw");
  }
  
  public void run() {
    
    boolean toSend = true;
    
    byte[] buf = new byte[256];
    byte[] Btime, Bid;
    long time_out;
    int id_out;
    InputStream in = null;
    OutputStream out = null;

    try{
      in = socket.getInputStream();
      out = socket.getOutputStream();
    }catch(IOException e) {
      System.out.println("Send: Unable to get input/output streams: " + e.getMessage());
//      socket.close();
      return;
    }
    
    while(toSend) {
      
      id_out = cBuffer.getID();
      Bid = (new Integer(id_out).toString()).getBytes();
      for (int i = 0; i < 8; i++)
	buf[i] = Bid[i];
      time_out = (new Date()).getTime();
      Btime = (new Long(time_out).toString()).getBytes();
      for (int i = 0; i < 12; i++)
	buf[i+8] = Btime[i];
      
//      if (cBuffer.addLog(id_out, time_out)){}
//	System.out.println("added: " +id_out+":"+time_out);
//      else
//	System.out.println("detected lost packet with id: " + id_out);
      
      try {
	// send packet
	out.write(buf);
	out.flush();

	packets_out++;
//	bytes_out += buf.length;
	bytes_out += 256;
	outputfile();

	sleep(sleeptime);
      } catch(Exception e) {
	System.out.println("Unable to send: " + e.getMessage());
	toSend = false;
      }
    }
  }
  
  private void outputfile() {
    try{
      file.seek(0L);
      file.writeBytes("Bytes sent: " + bytes_out + 
		      "\nPackets sent: " + packets_out);
    }catch (IOException e){
      System.out.println("Unable to write to output file");
    }
  }
  public void output() {
    System.out.println("Sent " + bytes_out + 
		       " bytes in " + packets_out + 
		       " packets");
  }
  
}


