// Implements a client
import java.io.*;
import java.net.*;
import java.util.*;

public class ClientUDPReceiveThread extends Thread {
  
  long packets_in = 0;
  long bytes_in = 0;
  long delay = 0;

  private RandomAccessFile file = null;

  DatagramSocket socket_udp;
  InetAddress address;
  int port;
  ClientBuffer cBuffer;

  public ClientUDPReceiveThread(DatagramSocket socket_udp, 
				InetAddress address, 
				int port, 
				ClientBuffer cBuffer,
				String outputfile) throws IOException {
    super("ClientReceiveThread");
    this.socket_udp = socket_udp;
    this.address = address;
    this.port = port;
    this.cBuffer = cBuffer;

    file = new RandomAccessFile(new File(outputfile+"_udp_r.out"), "rw");
  }
  
  public void run() {
    
    boolean toReceive = true;
    
    byte[] buf = new byte[256];
    byte[] Btime = new byte[12];
    byte[] Bid = new byte[8];
    long time_in;
    long packet_time;
    int packet_id;
//    String Stime = "";
    DatagramPacket packet;
    
    while(toReceive) {
      
      packet = new DatagramPacket(buf, buf.length, address, port);
      try {
	// receive packet
	socket_udp.receive(packet);
	time_in = (new Date()).getTime();
	buf = packet.getData();
	
	for (int i = 0; i < 12; i++){
	  Btime[i] = buf[i+8];
	}
	for (int i = 0; i < 8; i++){
	  Bid[i] = buf[i];
	}
	
	packet_id = Integer.parseInt(new String(Bid));
	packet_time = Long.parseLong(new String(Btime));
//     	System.out.println("time: " + packet_time);
	
	delay += (time_in - packet_time);
	

//	if (cBuffer.getLog(packet_id, packet_time))
//	  System.out.println("removed: " +packet_id+":"+packet_time);
//	else
//	  System.out.println("unable to remove: " +packet_id+":"+packet_time);

	packets_in++;
	bytes_in += packet.getLength();
	outputfile();
      }catch(Exception e) {
	System.out.println("Unable to receive: " + e.getMessage());
	//	toReceive = false;
      }
    }
  }

  private void outputfile() {
    try{
      file.seek(0L);
      file.writeBytes("Bytes received: " + bytes_in + 
		      "\nPackets received: " + packets_in);
    }catch (IOException e){
      System.out.println("Unable to write to output file");
    }
  }
  
  public void output(){
    System.out.println("Received " + bytes_in + 
		       " bytes in " + packets_in + 
		       " packets");
    System.out.println("Avg. Delay: " + (delay/packets_in));
  }
  
}


