// Implements a client
import java.io.*;
import java.net.*;
import java.util.*;

public class ClientUDPSendThread extends Thread {

  long packets_out = 0;
  long bytes_out = 0;
    
  private RandomAccessFile file = null;

  DatagramSocket socket_udp;
  InetAddress address;
  int port;
  ClientBuffer cBuffer;
  int sleeptime;

  public ClientUDPSendThread(DatagramSocket socket_udp, 
			     InetAddress address, 
			     int port, 
			     ClientBuffer cBuffer,
			     String outputfile,
			     int sleep) throws IOException {
    super("ClientSendThread");
    this.socket_udp = socket_udp;
    this.address = address;
    this.port = port;
    this.cBuffer = cBuffer;
    this.sleeptime = sleep;

    file = new RandomAccessFile(new File(outputfile+"_udp_s.out"), "rw");
  }
  
  public void run() {
    
    boolean toSend = true;
    
    byte[] buf = new byte[256];
    byte[] Btime, Bid;
    long time_out;
    int id_out;
//    String Stime = "";
    DatagramPacket packet;
    
    while(toSend) {
            
      packet = new DatagramPacket(buf, buf.length, address, port);
      
      time_out = (new Date()).getTime();
      id_out = cBuffer.getID();
      Btime = (new Long(time_out).toString()).getBytes();
      Bid = (new Integer(id_out).toString()).getBytes();
      for (int i = 0; i < 12; i++)
	buf[i+8] = Btime[i];
      for (int i = 0; i < 8; i++)
	buf[i] = Bid[i];
      
//      if (cBuffer.addLog(id_out, time_out)){}
//	System.out.println("added: " +id_out+":"+time_out);
//      else
//	System.out.println("detected lost packet with id: " + id_out);
      
      try {
	// send packet
	socket_udp.send(packet);

	packets_out++;
	bytes_out += packet.getLength();
	outputfile();

	sleep(sleeptime);
      } catch(Exception e) {
	System.out.println("Unable to send: " + e.getMessage());
	toSend = false;
      }
    }
  }
  
  private void outputfile() {
    try{
      file.seek(0L);
      file.writeBytes("Bytes sent: " + bytes_out + 
		      "\nPackets sent: " + packets_out);
    }catch (IOException e){
      System.out.println("Unable to write to output file");
    }
  }
  public void output() {
    System.out.println("Sent " + bytes_out + 
		       " bytes in " + packets_out + 
		       " packets");
  }
}


